import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.text.*;
/** 
 * Font Dialog permet de choisir les attribut graphiques
*/ 
public class FontDialog extends JDialog
{
  
  static public Vector readColor()
  {Vector result=null;
 try{
  FileReader f=new FileReader(FontDialog.color_filename);
  int number=0;
  int lect=0;
  
  while((lect=f.read())!=-1)
  {
  if (lect==(int)'1') number=number*10+1 ; else
  if (lect==(int)'2') number=number*10+2 ; else
  if (lect==(int)'3') number=number*10+3 ; else
  if (lect==(int)'4') number=number*10+4 ; else
  if (lect==(int)'5') number=number*10+5 ; else
  if (lect==(int)'6') number=number*10+6 ; else
  if (lect==(int)'7') number=number*10+7 ; else
  if (lect==(int)'8') number=number*10+8 ; else
  if (lect==(int)'9') number=number*10+9 ; else
  if (lect==(int)'0') number=number*10+0 ; else
  {
  if (result==null) result=new Vector(10,10);
  result.add(new Integer(number));
  System.err.println("nombre lut : "+number);
  number=0;}
  
  
  }
f.close();}
catch (Exception e) {};
  return result;
  }
  protected int m_option = JOptionPane.CLOSED_OPTION;
  protected OpenList m_lstFontName;
  protected OpenList m_lstFontSize;
  protected MutableAttributeSet m_attributes;
  protected JCheckBox m_chkBold;
  protected JCheckBox m_chkItalic;
  protected JCheckBox m_chkUnderline;
    
  protected JCheckBox m_chkStrikethrough;
  protected JCheckBox m_chkSubscript;
  protected JCheckBox m_chkSuperscript;
    
  protected JComboBox m_cbColor;
  protected JComboBox m_cbColorbg;
  protected JTextPane  m_preview;
  protected String t;
  public static String color_filename="color.rgb";
  public FontDialog(JFrame parent, 
    String[] names, String[] sizes)
  {
    super(parent, "Modify Style", true);
    getContentPane().setLayout(new BoxLayout(getContentPane(), 
      BoxLayout.Y_AXIS));
	t=new String ("Preview Font");
    JPanel p = new JPanel(new GridLayout(1, 2, 10, 2));
    p.setBorder(new TitledBorder(new EtchedBorder(), "Modify Style"));
    m_lstFontName = new OpenList(names, "Name:");
    p.add(m_lstFontName);

    m_lstFontSize = new OpenList(sizes, "Size:");
    p.add(m_lstFontSize);
    getContentPane().add(p);

    p = new JPanel(new GridLayout(2, 3, 10, 5));
    p.setBorder(new TitledBorder(new EtchedBorder(), "Effects"));
    m_chkBold = new JCheckBox("Bold");
    p.add(m_chkBold);
    m_chkItalic = new JCheckBox("Italic");
    p.add(m_chkItalic);
    m_chkUnderline = new JCheckBox("Underline");
    p.add(m_chkUnderline);
    m_chkStrikethrough = new JCheckBox("Strikeout");
    p.add(m_chkStrikethrough);
    m_chkSubscript = new JCheckBox("Subscript");
    p.add(m_chkSubscript);
    m_chkSuperscript = new JCheckBox("Superscript");
    p.add(m_chkSuperscript);
    getContentPane().add(p);

    getContentPane().add(Box.createVerticalStrut(5));
    p = new JPanel();
        p.setBorder(new TitledBorder(new EtchedBorder(), "Color"));
    p.setLayout(new GridLayout(2,2));
   // p.add(Box.createHorizontalStrut(10));
    p.add(new JLabel("Front Color:"));
   // p.add(Box.createHorizontalStrut(20));
    m_cbColor = new JComboBox();
Vector mycolor=readColor();
if (mycolor!=null)
{
	int ind=0;
	while (ind<mycolor.size())
		{
		int r=((Integer)mycolor.get(ind++)).intValue();
		int g=((Integer)mycolor.get(ind++)).intValue();
		int b=((Integer)mycolor.get(ind++)).intValue();
		System.err.println("("+r+","+g+","+b+")");
		Color c = new Color(r, g, b);
		m_cbColor.addItem(c);
		}
}
else
{
    int[] values = new int[] { 0, 128, 192, 255 };
    for (int r=0; r<values.length; r++) 
    {
      for (int g=0; g<values.length; g++) 
      {
        for (int b=0; b<values.length; b++) 
        {
          Color c = new Color(values[r], values[g], values[b]);
          m_cbColor.addItem(c);
        }
      }
    }
 
 }
 m_cbColorbg = new JComboBox();
 mycolor=null;
  mycolor=readColor();
if (mycolor!=null)
{
	int ind=0;
	while (ind<mycolor.size())
		{
		int r=((Integer)mycolor.get(ind++)).intValue();
		int g=((Integer)mycolor.get(ind++)).intValue();
		int b=((Integer)mycolor.get(ind++)).intValue();
		System.err.println("("+r+","+g+","+b+")");
		Color c = new Color(r, g, b);
		m_cbColorbg.addItem(c);
		}
}
else
{
  int[] values = new int[] { 0, 128, 192, 255 };
  
    for (int r=0; r<values.length; r++) {
      for (int g=0; g<values.length; g++) {
        for (int b=0; b<values.length; b++) {
          Color c = new Color(values[r], values[g], values[b]);
          m_cbColorbg.addItem(c);
        }
      }
    }}
    m_cbColorbg.setRenderer(new ColorComboRenderer());
   
    m_cbColor.setRenderer(new ColorComboRenderer());
    p.add(m_cbColor);
    p.add(new JLabel("Back Color:"));
   
    p.add(m_cbColorbg);
   // p.add(Box.createHorizontalStrut(10));
    getContentPane().add(p);

    p = new JPanel(new BorderLayout());
    p.setBorder(new TitledBorder(new EtchedBorder(), t));
    m_preview = new JTextPane();
    m_preview.setEditorKit(new StyledEditorKit());
    
 
    m_preview.setDocument(new DefaultStyledDocument(new StyleContext()));
    StyledDocument doc=m_preview.getStyledDocument();
   String filename=new String("Preview");
   int taille=doc.getLength();
           
try{ 
           MutableAttributeSet attr=new SimpleAttributeSet();
doc.insertString(0,filename,attr);
}catch (Exception h){System.out.println(h);}
    m_preview.setDoubleBuffered(true);
    m_preview.setEditable(false);
    m_preview.setBorder(new LineBorder(Color.black));
    m_preview.setPreferredSize(new Dimension(120, 40));
    p.add(m_preview, BorderLayout.CENTER);
    getContentPane().add(p);

    p = new JPanel(new FlowLayout());
    JPanel p1 = new JPanel(new GridLayout(1, 2, 10, 2));
    JButton btOK = new JButton("OK");
    ActionListener lst = new ActionListener() { 
      public void actionPerformed(ActionEvent e) {
        m_option = JOptionPane.OK_OPTION;
        setVisible(false);
      }
    };
    btOK.addActionListener(lst);
    p1.add(btOK);

    JButton btCancel = new JButton("Cancel");
    lst = new ActionListener() { 
      public void actionPerformed(ActionEvent e) {
        m_option = JOptionPane.CANCEL_OPTION;
        setVisible(false);
      }
    };
    btCancel.addActionListener(lst);
    p1.add(btCancel);
    p.add(p1);
    getContentPane().add(p);

    pack();
    setResizable(false);

    ListSelectionListener lsel = new ListSelectionListener() {
      public void valueChanged(ListSelectionEvent e) {
        updatePreview();
      }
    };
    m_lstFontName.addListSelectionListener(lsel);
    m_lstFontSize.addListSelectionListener(lsel);

    lst = new ActionListener() { 
      public void actionPerformed(ActionEvent e) {
        updatePreview();
      }
    };
    m_chkBold.addActionListener(lst);
    m_chkItalic.addActionListener(lst);
    m_cbColor.addActionListener(lst);
     
     m_cbColorbg.addActionListener(lst);
      m_chkSubscript.addActionListener(lst);
       m_chkStrikethrough.addActionListener(lst);
     m_chkSuperscript.addActionListener(lst);
     m_chkUnderline.addActionListener(lst);
  }
  public int getStatus(){return m_option;}
  /**
 * mets a jour l'example de la boite de dialogue
 */
  public void set_example(String ex,AttributeSet attr){t=new String(ex);
try{
        StyledDocument doc=m_preview.getStyledDocument();
int taille=doc.getLength();
  
 doc.remove(0, taille) ;
           
doc.insertString(0,ex,attr);
}catch (Exception bg){System.out.println(bg);}
  }
  /**
   * mets a jour les attribut graphique de l'exemple 
   */
  public void setAttributes(AttributeSet a) {
    m_attributes = new SimpleAttributeSet(a);
   
    String name = StyleConstants.getFontFamily(a);  
    m_lstFontName.setSelected(name);
    int size = StyleConstants.getFontSize(a);
    m_lstFontSize.setSelectedInt(size);
    m_chkBold.setSelected(StyleConstants.isBold(a));
    m_chkItalic.setSelected(StyleConstants.isItalic(a));
    m_chkUnderline.setSelected(StyleConstants.isUnderline(a));
    m_chkStrikethrough.setSelected(
      StyleConstants.isStrikeThrough(a));
    m_chkSubscript.setSelected(StyleConstants.isSubscript(a));
    m_chkSuperscript.setSelected(StyleConstants.isSuperscript(a));
    m_cbColor.setSelectedItem(StyleConstants.getForeground(a));
    m_cbColorbg.setSelectedItem(StyleConstants.getBackground(a));
    updatePreview();
  }

  public AttributeSet getAttributes() {
    /*if (m_attributes == null)
      return null;*/
      SimpleAttributeSet result=new SimpleAttributeSet();
    StyleConstants.setFontFamily(result, 
      m_lstFontName.getSelected());
    StyleConstants.setFontSize(result, 
      m_lstFontSize.getSelectedInt());
    StyleConstants.setBold(result, 
      m_chkBold.isSelected());
    StyleConstants.setItalic(result, 
      m_chkItalic.isSelected());
    StyleConstants.setUnderline(result, 
      m_chkUnderline.isSelected());
    StyleConstants.setStrikeThrough(result, 
      m_chkStrikethrough.isSelected());
    StyleConstants.setSubscript(result, 
      m_chkSubscript.isSelected());
    StyleConstants.setSuperscript(result, 
      m_chkSuperscript.isSelected());
    StyleConstants.setForeground(result, 
      (Color)m_cbColor.getSelectedItem());
   StyleConstants.setBackground(result,(Color)m_cbColorbg.getSelectedItem());
    repaint();
    return result;
  }
/**
 * renvoie le boolean option 
 */
  public int getOption() { return m_option; }

  protected void updatePreview() {
  /*  String name = m_lstFontName.getSelected();
    int size = m_lstFontSize.getSelectedInt();
    if (size <= 0)
      return;
    int style = Font.PLAIN;
    if (m_chkBold.isSelected())
      style |= Font.BOLD;
    if (m_chkItalic.isSelected())
      style |= Font.ITALIC;
    
    // Bug Alert! This doesn't work if only style is changed.
    Font fn = new Font(name, style, size);
    m_preview.setFont(fn);

    Color c = (Color)m_cbColor.getSelectedItem();
    m_preview.setForeground(c);
    m_preview.setBackground((Color)m_cbColorbg.getSelectedItem());
    m_preview.repaint();
    */
 try
{   AttributeSet attr=getAttributes();
      StyledDocument doc=m_preview.getStyledDocument();
      int taille=doc.getLength();
           
 doc.remove(0, taille) ;
           
doc.insertString(0,t,attr);
}
catch (Exception hg){System.out.println(hg);}
  }
}


