

import javax.swing.text.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import javax.swing.*;
import org.xml.sax.SAXException;
import javax.swing.event.*;


/**
 * MainFrame represente la fenetre mere de l'application 
 */
public class MainFrame extends JFrame
{	
/**
 * la zone d'edition
 */
protected  TextAreaPane _text1;
/** 
 * la fenetre de checking
 */
protected CheckDialog _text2;
/**
 * la fenetre d'edition des styles de balises
 */
protected StyleEditBalise _text3;
protected File _directorie;

/**
 * la liste des tags
 */
protected ListeTagIhm _text4;
protected ListeBalise _listeBalise;
//protected ContextMenu _contextmenu;
protected JToolBar _toolBar;
protected JMenuBar _menuBar;
protected ListeTag _listetag;
protected JLabel _status;
protected String _dtdfile;
protected XmlValidator _validator;
protected DTDValidator _dtdvalidator;
protected JSplitPane _split1;
protected JSplitPane _split2;
protected JSplitPane _split3;
protected JSplitPane _split4;
protected PreferenceDialog _pref;
private Action SaveFile()
{
ImageIcon iconOpen = new ImageIcon("export.gif");
Action toto = new AbstractAction("Export XML document", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) 
	{
	
	SimpleFilter m_txtFilter=new SimpleFilter("xml","Text Document");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
        Thread runner = new Thread() 
        {
	        public void run() {
        	 if (m_chooser.showSaveDialog(MainFrame.this) != JFileChooser.APPROVE_OPTION) return;
            	MainFrame.this.repaint();
            	MainFrame.this._directorie=m_chooser.getCurrentDirectory();

            	File fChoosen = new File(m_chooser.getSelectedFile().getAbsolutePath()+".xml");
		try {
                	 //_text1.load(fChoosen);
		 		FileWriter t=new FileWriter(fChoosen);
		 		PrintWriter pr=new PrintWriter(t,true);
		 		pr.print(GenerateXML.GenerateXML(_text1.getDocument(),_listetag,_dtdfile));
		 		pr.close();
		 		t.close();
			}
            	catch (Exception ex) {System.out.println(ex);}
            	MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
        }
};
runner.start();

	//System.out.println(GenerateXML.GenerateXML(_text1.getDocument(),_listetag));
	};

};
return (toto);


}


private Action Save()
{
ImageIcon iconOpen = new ImageIcon("saveb.gif");
Action toto = new AbstractAction("Save Balise File", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) 
	{
	try{
	SimpleFilter m_txtFilter=new SimpleFilter("sav","XmlViewer SaveFile");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
         if (m_chooser.showSaveDialog(MainFrame.this) != JFileChooser.APPROVE_OPTION) return;
            
            File fChoosen = new File(m_chooser.getSelectedFile().getAbsolutePath()+".sav");
	MainFrame.this._directorie=m_chooser.getCurrentDirectory();

	FileOutputStream ostream = new FileOutputStream(fChoosen);
	ObjectOutputStream p = new ObjectOutputStream(ostream);

  p.writeUTF(_dtdfile);
           p.writeObject(_listeBalise);
           p.close();
           
           MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    
           }
catch (Exception s){System.err.println(s);}
};
};
return (toto);
}

private Action SaveDocument()
{
ImageIcon iconOpen = new ImageIcon("file_save.gif");
Action toto = new AbstractAction("Save annoted document...", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) 
	{
	try{
	SimpleFilter m_txtFilter=new SimpleFilter("xmldoc","XmlViewer SaveFile");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
         if (m_chooser.showSaveDialog(MainFrame.this) != JFileChooser.APPROVE_OPTION) return;
            
            File fChoosen = new File(m_chooser.getSelectedFile().getAbsolutePath()+".xmldoc");
	MainFrame.this._directorie=m_chooser.getCurrentDirectory();

	FileOutputStream ostream = new FileOutputStream(fChoosen);
	ObjectOutputStream p = new ObjectOutputStream(ostream);

  	   p.writeUTF(_dtdfile);
           p.writeObject(_listeBalise);
           p.writeObject(_listetag);
           p.writeUTF(_text1.getDocument());
          
           p.close();
           
           MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    
           }
catch (Exception s){System.err.println(s);}
};
};
return (toto);
}

private Action Load()
{
ImageIcon iconOpen = new ImageIcon("openb.gif");
Action toto = new AbstractAction("Load balise document", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) 
	{
	
	try
	{SimpleFilter m_txtFilter=new SimpleFilter("sav","XmlViewer SaveFile");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
         if (m_chooser.showOpenDialog(MainFrame.this) != JFileChooser.APPROVE_OPTION) return;
            
            File fChoosen = m_chooser.getSelectedFile();
		MainFrame.this._directorie=m_chooser.getCurrentDirectory();

 FileInputStream istream = new FileInputStream(fChoosen);
	ObjectInputStream p = new ObjectInputStream(istream);
         _dtdfile=p.readUTF();
         _listeBalise=new ListeBalise();
         _listeBalise=(ListeBalise)p.readObject();
         
          _text3.UpDate(_listeBalise);
			
MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    
}
catch (Exception s){System.err.println(s);}
};
};
return (toto);
}

private Action LoadDocument()
{
ImageIcon iconOpen = new ImageIcon("file_open.gif");
Action toto = new AbstractAction("Load annoted document", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) 
	{
	
	try
	{SimpleFilter m_txtFilter=new SimpleFilter("xmldoc","XmlViewer SaveFile");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
         if (m_chooser.showOpenDialog(MainFrame.this) != JFileChooser.APPROVE_OPTION) return;
            
            File fChoosen = m_chooser.getSelectedFile();
		MainFrame.this._directorie=m_chooser.getCurrentDirectory();

 FileInputStream istream = new FileInputStream(fChoosen);
	ObjectInputStream p = new ObjectInputStream(istream);
         _dtdfile=p.readUTF();
         _listeBalise=new ListeBalise();
         _listeBalise=(ListeBalise)p.readObject();
         _listetag=(ListeTag)p.readObject();
         _text1.setDocument(p.readUTF());
    
           
          _text3.UpDate(_listeBalise);
          _text1.repaintTag(_listetag);
          _text4.SetTag(_listetag,_text1.getDocument());
          	
			
MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    
}
catch (Exception s){System.err.println(s);}
};
};
return (toto);
}
public void setPreference(SimpleAttributeSet sa)
{
_listeBalise.setDefaultStyle(sa,true);
_text1.repaintTag(_listetag);
_text3.UpDate(_listeBalise);
}
private Action Preference()
{
ImageIcon iconOpen = new ImageIcon("openb.gif");
Action toto = new AbstractAction("Preference(Experimental)", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) 
	{
	
	try
	{ _pref.setVisible(true);
		
}
catch (Exception s){System.err.println(s);}
};
};
return (toto);
}

/** 
 * mets a jour la ligne de status 
 */
public void setStatus(String status)
{
_status.setText(status);
_status.repaint();
}
/**
 * renvoie la liste des tags
 */
public ListeTag getTag(){return _listetag;}
private Action LoadFile()
{
ImageIcon iconOpen = new ImageIcon("file_new.gif");
Action toto = new AbstractAction("Import texte document", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) {
	SimpleFilter m_txtFilter=new SimpleFilter("txt","Text Document");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
        Thread runner = new Thread() 
        {
	        public void run() {
        	 if (m_chooser.showOpenDialog(MainFrame.this) != JFileChooser.APPROVE_OPTION) return;
            	MainFrame.this.repaint();
            	MainFrame.this._directorie=m_chooser.getCurrentDirectory();

            	File fChoosen = m_chooser.getSelectedFile();
		try {
                	 _text1.load(fChoosen);
		 	
		 		_listetag=new ListeTag();
			_text4.SetTag(_listetag,_text1.getDocument());
		 
			}
            	catch (Exception ex) {System.out.println(ex);}
            	MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
        }
};
runner.start();
}
};
return (toto);
}
private Action ValidatorStrict()
{
ImageIcon iconOpen = new ImageIcon("validS.gif");
Action toto = new AbstractAction("Open...", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) {
	_validator.Test(GenerateXML.GenerateXML(_text1.getDocument(),_listetag,_dtdfile),true);
	_validator.setVisible(true);
	}
};
return (toto);
}
private Action Validator()
{
ImageIcon iconOpen = new ImageIcon("valid.gif");
Action toto = new AbstractAction("Open...", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) {
	_validator.Test(GenerateXML.GenerateXML(_text1.getDocument(),_listetag,_dtdfile),false);
	_validator.setVisible(true);
	}
};
return (toto);
}

private Action LoadFileDTD()
{
ImageIcon iconOpen = new ImageIcon("dtd_open.gif");
Action toto = new AbstractAction("Open A DTD File", iconOpen) 
{ 
	public void actionPerformed(ActionEvent e) {
	SimpleFilter m_txtFilter=new SimpleFilter("dtd","DTD File");
	final JFileChooser m_chooser = new JFileChooser(); 
    	m_chooser.setCurrentDirectory(_directorie);
  	m_chooser.addChoosableFileFilter(m_txtFilter);
        m_chooser.setFileFilter(m_txtFilter);
        MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
        Thread runner = new Thread() 
        {
	        public void run() {
        	 if (m_chooser.showOpenDialog(MainFrame.this) != JFileChooser.APPROVE_OPTION) return;
            	MainFrame.this.repaint();
            	MainFrame.this._directorie=m_chooser.getCurrentDirectory();

		try {
			File fChoosen = m_chooser.getSelectedFile();
			
			DTDReader DReader=new DTDReader();
			_dtdfile=new String(fChoosen.getPath());
			 System.out.println(fChoosen.getAbsolutePath());
			 DReader.parseDTD(fChoosen.getAbsolutePath());
			 System.out.println(DReader.getData());
			 _listeBalise=DReader.getData();
			 _listeBalise.setDefaultStyle(_pref.getAttributesDefaultXML(),true);
			 _text3.UpDate(_listeBalise);
			_listetag=new ListeTag();
			_text4.SetTag(_listetag,_text1.getDocument());
		      
			}
            	catch (Exception ex) {
                        _dtdvalidator.Test(new String("Erreur dans lecture DTD")+ex.toString());
                        _dtdvalidator.setVisible(true);
                }
            	MainFrame.this.setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
        }
};
runner.start();
}
};
return (toto);
}

public void LectDTD(String filename)
{
try {
			
			DTDReader DReader=new DTDReader();
			_dtdfile=new String(filename);
			 System.out.println(filename);
			 DReader.parseDTD(filename);
			 System.out.println(DReader.getData());
			 _listeBalise=DReader.getData();
			 _listeBalise.setDefaultStyle(_pref.getAttributesDefaultXML(),true);
			 _text3.UpDate(_listeBalise);
			_listetag=new ListeTag();
			_text4.SetTag(_listetag,_text1.getDocument());
		      
			}
            	catch (Exception ex) {
                        _dtdvalidator.Test(new String("Erreur dans lecture DTD")+ex.toString());
                        _dtdvalidator.setVisible(true);
               }
}
/**
 * mets ajour la listes des tag
 */
public void UpDateTag()
{
_listetag.UpDateDocument(_text1);
}
/**
 * gere la selection d'un tag
 */
public void select(Tag t)
{
System.out.println("select Tag t "+t.toString());
_text1.repaintTag(_listetag);
_text2.init(t.getBalise(),t);
_text2.getViewport().setVisible(true);
_text1.select(t.getDebut(),t.getFin(),t.getBalise().getAttribut());
_text4.select(t);
}
/**
 * enleve un tag de la liste
 */
public boolean remove(Tag tag)
{
boolean result=_listetag.remove(tag);
_text1.repaintTag(_listetag);
_text4.SetTag(_listetag,_text1.getDocument());
return result;
}
public boolean removeGroup(Tag tag)
{
boolean result=_listetag.removeGroup(tag);
_text1.repaintTag(_listetag);
_text4.SetTag(_listetag,_text1.getDocument());
return result;
}

/**
 * mets jour graphiquement les differentes fenetres avec une position dans le texte
 */
public void UpDateChild(int pos)
{
Tag t=_listetag.search(pos);
if (t!=null) 
{
	_text2.init(t.getBalise(),t);
	_text2.getViewport().setVisible(true);
	_text1.repaintTag(_listetag);
	_text1.select(t.getDebut(),t.getFin(),t.getBalise().getAttribut());
        _text4.select(t);
}
	else 
	{
		_text2.getViewport().setVisible(false);
		_text1.repaintTag(_listetag);
	}
}
/**
 * mets a jour la liste des tags Ihm
 */
public void UpDateListe()
{
_text4.SetTag(_listetag,_text1.getDocument());
}
/**
 * Update le changement graphique d'une balise
 */
public void viewLigne(int ligne)
{
System.err.println("ligne a scroller :"+ligne);
_text1.scroll(ligne);
}
public void UpDateChild(Balise b,MutableAttributeSet attrM)
{
/* Est ce un tag */
/* oui  on init  avec le tag */


/* non on mais a jour la couleur et on enregistre le tag */
System.out.println("MainFrame::UpDateChild(Balise,MutableAttributSet");
/*if (_text1.setAttributeSet(attrM))
{*/

Tag tag=new Tag(b,_text1.get_debut(),_text1.get_fin(),_text1.getLigne(_text1.get_debut()));
//_text1.setDot(_text1.get_debut()) ;
_text1.GereFin(_text1.get_fin());
_listetag.add(tag);
XmlNode test=new XmlNode();
test.Init(_listetag);
_listetag=test.toListeTag();
_text1.setListeTag(_listetag);
_text3.Activate(b);
_text2.init(b,tag);
new Thread()
{
public void run()
{
_text4.SetTag(_listetag,_text1.getDocument());
_text1.repaintTag(_listetag);
}
}.start();
//}
}
/**
 * Cree la bar de menu
 */
public JMenuBar create_JMenuBar()
	{
	JMenuBar menuBar = new JMenuBar();
	JMenu mFile = new JMenu("File");
    mFile.setMnemonic('f');
	
	
 JMenuItem item =  mFile.add(LoadFile());
  item=mFile.add(LoadDocument());
 item=mFile.add(SaveDocument());

 item=mFile.add(LoadFileDTD());
   item=mFile.add(SaveFile());
   mFile.add(item);
   
 JMenu mEdit = new JMenu("Edit");
    mEdit.setMnemonic('e');

    Action action = new AbstractAction("Copy", 
     new ImageIcon("edit_copy.gif")) 
    { 
      public void actionPerformed(ActionEvent e) {
        _text1.copy();
      }
    };
    item = mEdit.add(action);  
    item.setMnemonic('c');
    item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C, 
      KeyEvent.CTRL_MASK));

    action = new AbstractAction("Cut", 
     new ImageIcon("edit_cut.gif")) 
    { 
      public void actionPerformed(ActionEvent e) {
        _text1.cut();
      }
    };
    item = mEdit.add(action);  
    item.setMnemonic('t');
    item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X, 
      KeyEvent.CTRL_MASK));

    action = new AbstractAction("Paste", 
     new ImageIcon("edit_paste.gif")) 
    { 
      public void actionPerformed(ActionEvent e) {
        _text1.paste();
      }
    };
    item = mEdit.add(action);  
    item.setMnemonic('p');
    item.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_V, 
      KeyEvent.CTRL_MASK));
      
	_pref=new PreferenceDialog(MainFrame.this, GraphicsEnvironment.
      getLocalGraphicsEnvironment().getAvailableFontFamilyNames());
	JMenu mBalise = new JMenu("Balise");
	 mBalise.add(Save());
 	mBalise.add(Load());
mBalise.add(Preference());

   	menuBar.add(mFile);
   	menuBar.add(mEdit);
   	menuBar.add(mBalise);
   	
	menuBar.setVisible(true);
	return menuBar;
	}
/**
 * Cree la bar des boutons
 */
public JToolBar createToolBar()
{
 JToolBar m_toolBar = new JToolBar();
    JButton bOpen = new SmallButton(LoadFile(), "Import texte document ");
    JButton bOpenXML = new SmallButton(LoadDocument(), "Load annoted document ");
    JButton bSaveXML = new SmallButton(SaveDocument(), "Save annoted document");
   
    JButton bOpenDTD = new SmallButton(LoadFileDTD(), "Open a DTD file");
   JButton validS=new SmallButton(ValidatorStrict(),"Valid  document with DTD");
   JButton valid=new SmallButton(Validator(),"Valid quickly document");
    m_toolBar.add(bOpen);
     m_toolBar.add(bOpenXML);
      m_toolBar.add(bSaveXML);
      m_toolBar.addSeparator();
     m_toolBar.add(bOpenDTD);
    m_toolBar.addSeparator();
   m_toolBar.add(_status);
   	m_toolBar.add(validS);
	m_toolBar.add(valid);
   return (m_toolBar);
}
protected void OnSize()
 {
 _split1.setDividerLocation(.5);
_split2.setDividerLocation(.75);
_split3.setDividerLocation(.75);
 }
/**
 * Constructeur de la fenetre
 */
 
public MainFrame()
{
super();
setSize(600, 400);
_directorie=new File(".");

_status=new JLabel();
_text1=new TextAreaPane(this);
_text2=new CheckDialog(this);
_text3=new StyleEditBalise(this);
_text4=new ListeTagIhm(this);
try
{ _split1=new JSplitPane(JSplitPane.VERTICAL_SPLIT,_text2,_text3);
  _split1.setDividerLocation(.5);

 _split2=new JSplitPane(JSplitPane.VERTICAL_SPLIT,_text1,_text4);
 _split2.setDividerLocation(.75);

 _split3=new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,_split2,_split1);
_split3.setDividerLocation(.75);

this.addWindowListener(new WindowAdapter()
		{
		public void windowClosing(WindowEvent e)
		{
			System.exit(0);
		}
		public void windowDeiconified(WindowEvent e) 
           
           	{
           	OnSize();
           	}
		public void windowOpened(WindowEvent e) 
		{
		OnSize();
		}
           
		}
);

_listetag=new ListeTag();
_validator=new XmlValidator(this);
_dtdvalidator=new DTDValidator(this);
_toolBar=createToolBar();

getContentPane().add(_split3, BorderLayout.CENTER);
getContentPane().add(_toolBar, BorderLayout.NORTH);
_menuBar=create_JMenuBar();
setJMenuBar(_menuBar);

setVisible(true);
}
catch (Exception e) {System.err.println(e);System.err.println("Erreur D'initialisation des splitting pane");System.exit(0);}
}

public void init()
{repaint();
OnSize();
repaint();
_text3.GereDefault();	
}

 

public static void main(String [] args)
{
 
(new MainFrame()).init();

}
}
